import { IAppCheck, IAppCheckToken } from './common';
import { FirebaseApp } from '@nativescript/firebase-core';
export declare class AppCheckToken implements IAppCheckToken {
    #private;
    static fromNative(token: com.google.firebase.appcheck.AppCheckToken): AppCheckToken;
    get native(): com.google.firebase.appcheck.AppCheckToken;
    get android(): com.google.firebase.appcheck.AppCheckToken;
    get token(): string;
    get expireTimeMillis(): number;
}
export declare class AppCheck implements IAppCheck {
    #private;
    constructor(app?: FirebaseApp);
    activate(isTokenAutoRefreshEnabled: boolean): void;
    getToken(forceRefresh: boolean): Promise<AppCheckToken>;
    setTokenAutoRefreshEnabled(enabled: boolean): void;
    get native(): com.google.firebase.appcheck.FirebaseAppCheck;
    get ios(): com.google.firebase.appcheck.FirebaseAppCheck;
    get app(): FirebaseApp;
}
