import { IAppCheck, IAppCheckToken } from './common';
import { FirebaseApp } from '@nativescript/firebase-core';
export declare class AppCheckToken implements IAppCheckToken {
    #private;
    static fromNative(token: FIRAppCheckToken): AppCheckToken;
    get native(): FIRAppCheckToken;
    get ios(): FIRAppCheckToken;
    get token(): string;
    get expireTimeMillis(): number;
}
export declare class AppCheck implements IAppCheck {
    #private;
    constructor(app?: FirebaseApp);
    activate(isTokenAutoRefreshEnabled: boolean): void;
    getToken(forceRefresh: boolean): Promise<AppCheckToken>;
    setTokenAutoRefreshEnabled(enabled: boolean): void;
    get native(): FIRAppCheck;
    get ios(): FIRAppCheck;
    get app(): FirebaseApp;
}
