var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _AppCheckToken_native, _AppCheck_native, _AppCheck_app;
import { firebase, FirebaseApp, FirebaseError } from '@nativescript/firebase-core';
let defaultAppCheck;
const fb = firebase();
Object.defineProperty(fb, 'appCheck', {
    value: (app) => {
        if (!app) {
            if (!defaultAppCheck) {
                defaultAppCheck = new AppCheck();
            }
            return defaultAppCheck;
        }
        return new AppCheck(app);
    },
    writable: false,
});
export class AppCheckToken {
    constructor() {
        _AppCheckToken_native.set(this, void 0);
    }
    static fromNative(token) {
        if (token instanceof FIRAppCheckToken) {
            const t = new AppCheckToken();
            __classPrivateFieldSet(t, _AppCheckToken_native, token, "f");
            return t;
        }
        return null;
    }
    get native() {
        return __classPrivateFieldGet(this, _AppCheckToken_native, "f");
    }
    get ios() {
        return this.native;
    }
    get token() {
        return this.native?.token;
    }
    get expireTimeMillis() {
        return this.native?.expirationDate?.getTime?.();
    }
}
_AppCheckToken_native = new WeakMap();
export class AppCheck {
    constructor(app) {
        _AppCheck_native.set(this, void 0);
        _AppCheck_app.set(this, void 0);
        if (app?.native) {
            __classPrivateFieldSet(this, _AppCheck_native, FIRAppCheck.appCheckWithApp(app.native), "f");
        }
        else {
            if (defaultAppCheck) {
                return defaultAppCheck;
            }
            defaultAppCheck = this;
            __classPrivateFieldSet(this, _AppCheck_native, FIRAppCheck.appCheckWithApp(FIRApp.defaultApp()), "f");
        }
    }
    activate(isTokenAutoRefreshEnabled) {
        this.native.isTokenAutoRefreshEnabled = isTokenAutoRefreshEnabled;
    }
    getToken(forceRefresh) {
        return new Promise((resolve, reject) => {
            this.native.tokenForcingRefreshCompletion(false, (token, error) => {
                if (error) {
                    const err = FirebaseError.fromNative(error);
                    reject(err);
                }
                else {
                    resolve(AppCheckToken.fromNative(token));
                }
            });
        });
    }
    setTokenAutoRefreshEnabled(enabled) {
        this.native.isTokenAutoRefreshEnabled = enabled;
    }
    get native() {
        return __classPrivateFieldGet(this, _AppCheck_native, "f");
    }
    get ios() {
        return this.native;
    }
    get app() {
        if (!__classPrivateFieldGet(this, _AppCheck_app, "f")) {
            // @ts-ignore
            __classPrivateFieldSet(this, _AppCheck_app, FirebaseApp.fromNative(this.native.app), "f");
        }
        return __classPrivateFieldGet(this, _AppCheck_app, "f");
    }
}
_AppCheck_native = new WeakMap(), _AppCheck_app = new WeakMap();
//# sourceMappingURL=index.ios.js.map